/*
 * EksempelInterface.java   E.L. 2004-02-24
 *
 * Filen inneholder et interface og en klasse som implementerer dette,
 * samt et lite testprogram
 */

interface Sammenligningsbar<Type> {
  /* public abstract er underforsttt for metoder */
  boolean strreEnn(Type obj);
  boolean mindreEnn(Type obj);
  boolean lik(Type obj);
}

class FireSifretHeltall implements Sammenligningsbar<FireSifretHeltall> {
  private static final int min = 1000;
  private static final int maks = 9999;
  private int verdi;

  public FireSifretHeltall(int startVerdi) {
    if (startVerdi < min) verdi = min;
    else if (startVerdi > maks) verdi = maks;
    else verdi = startVerdi;
  }

  public int finnVerdi() {
    return verdi;
  }

  public boolean strreEnn(FireSifretHeltall tall) {
    return (verdi > tall.finnVerdi());
  }

  public boolean mindreEnn(FireSifretHeltall tall) {
    return (verdi < tall.finnVerdi());
  }

  public boolean lik(FireSifretHeltall tall) {
    return (verdi == tall.finnVerdi());
  }
}

class EksempelInterface {
  public static void main(String[] args) {
    FireSifretHeltall tall1 = new FireSifretHeltall(700);
    FireSifretHeltall tall2 = new FireSifretHeltall(1700);
    FireSifretHeltall tall3 = new FireSifretHeltall(70000);
    System.out.println(tall1.finnVerdi());
    System.out.println(tall2.finnVerdi());
    System.out.println(tall3.finnVerdi());
    System.out.println(tall1.strreEnn(tall2));
    System.out.println(tall1.mindreEnn(tall2));
    System.out.println(tall1.lik(tall2));
  }
}

/* Utskrift:
1000
1700
9999
false
true
false
*/
