/*
 * Flate.java   E.L. 2002-09-04
 *
 * Klassen Flate tilbyr metoder for beregning av areal og omkrets.
 * Denne utgaven er til bruk i kapittel 10. Den har ftt inn
 * opplysninger om materialtype som flaten skal males med. Dette er
 * implementasjonen av assosiasjonen "bruker" p figur 10.9.
 *
 * Klassen er mutabel, materialtype kan endres.
 */

import java.text.DecimalFormat;
class Flate {
  private String navn;  // til identifikasjon
  private double lengde;
  private double bredde;
  private Materiale materialtype;

  /* Utskrift-formatet brukes i toString()-metoden */
  public static final DecimalFormat utskriftFormat =
                                         new DecimalFormat("####0.00");

  /*
   * Materiale registreres ikke i konstruktren. Det m vre lov  lage flater uten
   * samtidig  knytte materiale til dem. Materiale registreres ved bruk av settMateriale()
   */
  public Flate(String startNavn, double startLengde, double startBredde) {
    navn = startNavn;
    lengde = startLengde;
    bredde = startBredde;
  }

  public String finnNavn() {
    return navn;
  }

  public Materiale finnMateriale() {  // returnerer null dersom materaile ikke registrert
    return materialtype;
  }

  public void settMateriale(Materiale nyMaterialtype) {
    materialtype = nyMaterialtype;
  }

  public double finnLengde() {
    return lengde;
  }

  public double finnBredde() {
    return bredde;
  }

  public double finnAreal() {
    return bredde * lengde;
  }

  public double finnOmkrets() {
    return 2 * (lengde + bredde);
  }

  /* Materialtype er ogs tatt med her */
  public String toString() {
    String resultat = "Flate: " + navn + ", bredde: " + utskriftFormat.format(bredde) +
           " m, lengde: " + utskriftFormat.format(lengde) + " m";
    if (materialtype != null) resultat += ", dekkes med " + materialtype.finnNavn();
    else resultat += " Materialtype ikke registrert. ";
    return resultat;
  }
}