/*
 * Materiale.java   E.L. 2004-04-03
 *
 * Felles superklasse for ulike typer materialer til bruk ved oppussing.
 */

import java.text.DecimalFormat;
abstract class Materiale {
  private DecimalFormat utskriftFormat = new DecimalFormat("####0.00");
  private String navn;  // identifiserer materialet
  private double pris;  // pris pr enhet

  public Materiale(String startNavn, double startPris) {
    navn = startNavn;
    pris = startPris;
  }

  public String finnNavn() {
    return navn;
  }

  public double finnPrisPrEnhet() {
    return pris;
  }

  public double finnTotalpris(Flate enFlate) {
    return finnMaterialbehov(enFlate) * pris;
  }

  public abstract double finnMaterialbehov(Flate enFlate);

  public String toString() {
    return navn + ", pris kr. " + utskriftFormat.format(pris);
  }

  /* Subklasser kan bruke samme format */
  protected DecimalFormat finnFormat() {
    return utskriftFormat;
  }
}