/*
 * Persontest.java   E.L. 2004-03-20
 *
 * Filen inneholder fire klasser:
 * Person: Data om en person; fdselsnummer, navn og adresse
 * Student og Ansatt: Subklasser til Person
 * Persontest: Enkelt testprogram som viser bruk av toString() og arv av metoder
 */

class Person {
  private long fnr;
  private String navn;
  private String adresse;

  public Person(long startFnr, String startNavn, String startAdr) {
    fnr = startFnr;
    navn = startNavn;
    adresse = startAdr;
  }

  public long finnFnr() {
    return fnr;
  }

  public String finnNavn() {
    return navn;
  }

  public String finnAdresse() {
    return adresse;
  }

  public String toString() {
    return "f.nr.: " + fnr + ", navn: " + navn + ", adresse: " + adresse;
  }
}

class Student extends Person {
  private long studnr;

  public Student(long startFnr, String startNavn, String startAdr,
      long startStudnr) {
    super(startFnr, startNavn, startAdr);
    studnr = startStudnr;
  }

  public long finnStudnr() {
    return studnr;
  }

  public String toString() {
    return "Student: stud.nr.: " + studnr + " " + super.toString();
  }
}

class Ansatt extends Person {
  private int lnnstrinn;

  public Ansatt(long startFnr, String startNavn, String startAdr,
      int startLnnstrinn) {
    super(startFnr, startNavn, startAdr);
    lnnstrinn = startLnnstrinn;
  }

  public int finnLnnstrinn() {
    return lnnstrinn;
  }

  public String toString() {
    return "Ansatt: lnnstrinn: " + lnnstrinn + " " + super.toString();
  }
}

class Persontest {
  public static void main(String[] args) {
    Student studenten = new Student(12106078756L, "Ole B", "Storgt 3, 2345 Os", 1234567L);
    Ansatt lreren = new Ansatt(5107078056L, "Hanne Hansen", "Lia, 3456 Mo", 40);
    System.out.println("Utskrift med bruk av toString():\n" + studenten + "\n" + lreren);
    System.out.println("\nUtskrift med bruk av finnmetoder, de fleste arvet:");
    System.out.println("Studenten: " + studenten.finnFnr() + ", " + studenten.finnNavn()
       + ", " + studenten.finnAdresse() + ", stud.nr.: " + studenten.finnStudnr());
    System.out.println("Lreren: " + " " + lreren.finnFnr() + ", " + lreren.finnNavn()
       + ", " + lreren.finnAdresse() + ", lnnstrinn " + lreren.finnLnnstrinn());
  }
}

/* Utskrift:
Utskrift med bruk av toString():
Student: stud.nr.: 1234567 f.nr.: 12106078756, navn: Ole B, adresse: Storgt 3, 2345 Os
Ansatt: lnnstrinn: 40 f.nr.: 5107078056, navn: Hanne Hansen, adresse: Lia, 7001 Trondheim\n

Utskrift med bruk av finnmetoder, de fleste arvet:
Studenten: 12106078756, Ole B, Storgt 3, 2345 Os, stud.nr.: 1234567
Lreren:  5107078056, Hanne Hansen, Lia, 7001 Trondheim, lnnstrinn 40
*/
