/*
 * Belegg.java   E.L. 2002-09-04
 *
 */

class Belegg extends Materiale {
  private static final double grense = 0.02; // grense for  beregne en bredde ekstra
  private double breddePBelegg;    // meter

  public Belegg(String startNavn, double startPris, double startBredde) {
    super(startNavn, startPris);
    breddePBelegg = startBredde;
  }

  public double finnBredde() {
    return breddePBelegg;
  }

  /*
   * Skal beregne antall meter som trengs til en flate.
   * Teppet legges alltid p tvers av golvets lengde.
   * For  finne ut om det er billigere  legge teppet andre veien,
   * m klienten bytte om lengde og bredde i den flaten som
   * sendes inn som argument.
   */
  public double finnMaterialbehov(Flate enFlate) {
    double lengdeFlate = enFlate.finnLengde();
    double breddeFlate = enFlate.finnBredde();

    int antBredder = (int)(lengdeFlate / breddePBelegg);
    double rest = lengdeFlate % breddePBelegg;
    if (rest >= grense) antBredder++;
    return antBredder * breddeFlate;
  }

  public String toString() {
    return "Belegg: " + super.toString() + " pr. m, bredde: " +
            finnFormat().format(breddePBelegg) + " m.";
  }
}