/*
 * Maling.java   E.L. 2002-09-04
 *
 */

class Maling extends Materiale {
  private static final double grense = 0.02;  // grense for  kjpe 0.5 liter maling til
  private int antStrk;
  private double antKvmPrLiter;

  public Maling(String startNavn, double startPris, int startAntStrk, double startAntKvmPrLiter) {
    super(startNavn, startPris);
    antStrk = startAntStrk;
    antKvmPrLiter = startAntKvmPrLiter;
  }

  public int finnAntStrk() {
    return antStrk;
  }

  public double finnAntKvmPrLiter() {
    return antKvmPrLiter;
  }

  /*
   * Metoden finner antall liter maling som trengs,
   * behovet rundes oppover til nrmeste halve liter.
   */
  public double finnMaterialbehov(Flate enFlate) {
    double areal = enFlate.finnAreal();
    double antLiter = areal * antStrk / antKvmPrLiter;
    int heltAntallLitere = (int) antLiter;
    double overLiteren = antLiter - heltAntallLitere;
    if (overLiteren >= 0.5 + grense) return heltAntallLitere + 1.0;
    else if (overLiteren >= grense) return heltAntallLitere + 0.5;
    else return heltAntallLitere;
  }

  public String toString() {
    return "Maling: " + super.toString() + " pr liter, ant. strk: " + antStrk +
           ", ant. kvm/l: "  + finnFormat().format(antKvmPrLiter);
  }
}