/*
 * Maling.java   E.L. 2002-07-23
 *
 * Klassen Maling tilbyr metoder for beregning av materialbehov og pris.
 */

// Lsning oppgave 8.6.2.
import java.text.DecimalFormat;
class Maling implements java.io.Serializable {
  public static final DecimalFormat utskriftFormat = new DecimalFormat("####0.00");
  private static final double grense = 0.02;  // grense for  kjpe 0.5 liter maling til
  private String navn;  // identifiserer malingen
  private double pris;  // pr.liter
  private int antStrk;
  private double antKvmPrLiter;

  public Maling(String startNavn, double startPris, int startAntStrk, double startAntKvmPrLiter) {
    navn = startNavn;
    antStrk = startAntStrk;
    antKvmPrLiter = startAntKvmPrLiter;
    pris = startPris;
  }

  public String finnNavn() {
    return navn;
  }

  public double finnPrisPrLiter() {
    return pris;
  }

  public int finnAntStrk() {
    return antStrk;
  }

  public double finnAntKvmPrLiter() {
    return antKvmPrLiter;
  }

  /*
   * Metoden finner antall liter maling som trengs,
   * behovet rundes oppover til nrmeste halve liter.
   */
  public double finnAntLiter(Flate enFlate) {
    double areal = enFlate.finnAreal();
    double antLiter = areal * antStrk / antKvmPrLiter;
    int heltAntallLitere = (int) antLiter;
    double overLiteren = antLiter - heltAntallLitere;
    if (overLiteren >= 0.5 + grense) return heltAntallLitere + 1.0;
    else if (overLiteren >= grense) return heltAntallLitere + 0.5;
    else return heltAntallLitere;
  }

  public double finnTotalpris(Flate enFlate) {
    return finnAntLiter(enFlate) * pris;
  }

  public String toString() {
    return "Maling: " + navn + ", pris kr " + utskriftFormat.format(pris) +
           " pr. liter, ant. strk: " + antStrk + ", ant. kvm/l: "  +
           utskriftFormat.format(antKvmPrLiter);
  }
}