/*
 * Tapet.java   E.L. 2006-08-16
 *
 */

package oppussingsprosjekt;

public class Tapet extends Materiale {
  private static final double grense = 0.02; // grense for  beregne en rull ekstra
  private double lengdePrRull;    // meter
  private double breddePrRull;    // meter

  public Tapet(String startNavn, double startPris, double startLengde, double startBredde) {
    super(startNavn, startPris);
    lengdePrRull = startLengde;
    breddePrRull = startBredde;
  }

  public double finnLengde() {
    return lengdePrRull;
  }

  public double finnBredde() {
    return breddePrRull;
  }

  /*
   * Metoden finner totalt antall ruller som trengs for  tapetsere en flate.
   */
  public double finnMaterialbehov(Flate enFlate) {
    double lengdeFlate = enFlate.finnLengde();
    double hydeFlate = enFlate.finnBredde();

    /* finner antall hyder vi trenger: */
    int antHyder = (int) (lengdeFlate / breddePrRull);
    double rest = lengdeFlate % breddePrRull;
    if (rest >= grense) antHyder++;

    /* finner antall ruller som trengs */
    int antRuller;
    int antHyderPrRull = (int) (lengdePrRull / hydeFlate);
    if (antHyderPrRull > 0) {
      antRuller = antHyder / antHyderPrRull;
      rest = antHyder % antHyderPrRull;
      if (rest >= grense) antRuller++;
    } else {  // rullen er for kort til  dekke en hyde (sjelden!)
      double totAntMeter = antHyder * hydeFlate;
      antRuller = (int) (totAntMeter / lengdePrRull);
      if (totAntMeter % lengdePrRull >= grense) antRuller++;
    }
    return antRuller;
  }

  public String toString() {
    return "Tapet: " + super.toString() + " pr. rull, lengde rull: " +
           finnFormat().format(lengdePrRull) + " m, bredde rull: " +
           finnFormat().format(breddePrRull) + " m";
  }
}