/*
 * Tekstskur.java VBH 2004-04-17
 *
 * Demonstrasjon av kommunikasjon mellom trder gjennom at trdene venter
 * med  skrive ut tekst til bruker har tastet inn teksten.
 *
 * Filen inneholder tre klasser:
 * Skriver: Har ansvaret for  skrive en tekst. Har metode for  lese inn
 *          tekst ogs.
 * Tekstskriver: Trd som benytter Skriver til  skrive tekst.
 * Tekstskur: Hovedprogram. Et antall trder lages, og en av skriverne
 *            bes om  lese inn tekst fra bruker.
 */

import javax.swing.JOptionPane;

/*
 * Objekter av denne klassen kan skrive ut en gitt tekst.
 */
class Skriver {
  private String tekstSomSkrives = "";

  public synchronized void nyTekstFraBruker() {
    /* Leser en ny tekst via dialogvindu */
    tekstSomSkrives = JOptionPane.showInputDialog("Skriv inn ny tekst: ");
    if (!tekstSomSkrives.equals("")) {
      notifyAll();
    }
  }

  /* Metoden skriver ut objektets tekst dersom den ikke er
   *  tom. Er den det, kalles wait(), for  vente p at en annen
   *  trd fr lagt inn en tekst.
   */
  public synchronized void skrivTekst() {
    while (tekstSomSkrives.equals("")) {
      try {
        wait();
      }
      catch (InterruptedException e) {
      }
    }
    System.out.print("Tekst er: ");
    System.out.println(tekstSomSkrives);
    notifyAll(); // Ferdig, kan vekke de andre.
  }
}


class Tekstskriver extends Thread {
  private Skriver skriveren;

  public Tekstskriver(Skriver skriver) {
    skriveren = skriver;
  }

  public void run() {
    while (true) {
      skriveren.skrivTekst();
    }
  }
}

public class Tekstskur {
  public static void main(String[] args) {
    Skriver enSkriver = new Skriver();
    Tekstskriver skriver1 = new Tekstskriver(enSkriver);
    Tekstskriver skriver2 = new Tekstskriver(enSkriver);
    Tekstskriver skriver3 = new Tekstskriver(enSkriver);
    Tekstskriver skriver4 = new Tekstskriver(enSkriver);
    Tekstskriver skriver5 = new Tekstskriver(enSkriver);
    skriver1.start();
    skriver2.start();
    skriver3.start();
    skriver4.start();
    skriver5.start();
    enSkriver.nyTekstFraBruker();
  }
}

/* Utskrift fra dette programmet blir ingenting helt til brukeren har
 * skrevet en tekst i dialogvinduet. Deretter skrives denne teksten om
 * og om igjen.
 */
