/*
 * ElementListe.java VBH 2004-02-26
 *
 * Klassen innkapsler en lenket liste
 * 
 */
class ElementListe<Type> {
  private ListeElement<Type> frsteElement;

  /* Metoden returnerer innholdet i listen i tekstlig form. */
  public String toString() {
    String listeTekst = "";
    ListeElement<Type> hjelpeReferanse = frsteElement;
    while (hjelpeReferanse != null) {
      listeTekst += hjelpeReferanse.finnElement().toString() + "\n";
      hjelpeReferanse = hjelpeReferanse.finnNeste();
    }
    return listeTekst;
  }

  public void settInnElementTilSlutt(Type nyttElement) {
    ListeElement<Type> hjelpeReferanse = frsteElement;
    ListeElement<Type> hjelpeReferanseRettBak = null;
    /* Vi starter med  bevege oss fram til slutten av listen. */
    while (hjelpeReferanse != null) {
      hjelpeReferanseRettBak = hjelpeReferanse;
      hjelpeReferanse = hjelpeReferanse.finnNeste();
    }
    if (hjelpeReferanseRettBak == null ) {
      /* Dette skjer om listen var tom fra fr. */
      frsteElement = new ListeElement<Type>(nyttElement);
    } else {
      /* 
       * Dette skjer dersom det var minst ett element i listen fra
       * fr. hjelpeReferanseRettBak refererer n til det siste
       * elementet. 
       */
      hjelpeReferanseRettBak.settNeste(new ListeElement<Type>(nyttElement));
    }
  }

  public boolean skEtterElement(Type skeElement) {
    ListeElement<Type> hjelpeReferanse = frsteElement;
    while (hjelpeReferanse != null) {
      if (hjelpeReferanse.finnElement().equals(skeElement)) return true;
      hjelpeReferanse = hjelpeReferanse.finnNeste();
    }
    return false;
  }

  /* 
   * Denne metoden sletter alle forekomster av det gitte elementet fra
   * listen. 
   */
  public void slettElement(Type elementSomSkalSlettes) {
    ListeElement<Type> hjelpeReferanse = frsteElement;
    ListeElement<Type> hjelpeReferanseRettBak = null;
    /* Vi starter med  iterere oss framover i listen. */
    while (hjelpeReferanse != null) {
      if (hjelpeReferanse.finnElement().equals(elementSomSkalSlettes)) {
          /* 
           * Hjelpereferanse refererer n til et element som skal
           * slettes. Vi m ha spesialbehandling dersom dette er det
           * frste elementet i listen. 
           */
          if (hjelpeReferanseRettBak != null) {
              hjelpeReferanseRettBak.settNeste(hjelpeReferanse.finnNeste());
            } else {
              frsteElement = hjelpeReferanse.finnNeste();
            }
            hjelpeReferanse = hjelpeReferanse.finnNeste();
         } else {
            hjelpeReferanseRettBak = hjelpeReferanse;
            hjelpeReferanse = hjelpeReferanse.finnNeste();
      }
    }
  }
}
