/*
 * NavneListe.java VBH 2000-02-17
 *
 * Klassen innkapsler en lenket liste hvor hvert element inneholder en
 * tekst.
 * 
 */

class NavneListe {
  private NavneElement frsteElement;
  
  /* Metoden returnerer innholdet i listen i tekstlig form. */
  public String toString() {
    String listeTekst = "";
    NavneElement hjelpeReferanse = frsteElement;
    while (hjelpeReferanse != null) {
      listeTekst = listeTekst + hjelpeReferanse.finnNavn() + "\n";
      hjelpeReferanse = hjelpeReferanse.finnNeste();
    }
    return listeTekst;
  }
  
  public void settInnNavnTilSlutt(String nyttNavn) {
    NavneElement hjelpeReferanse = frsteElement;
    NavneElement hjelpeReferanseRettBak = null;
    /* Vi starter med  bevege oss fram til slutten av listen. */
    while (hjelpeReferanse != null) {
      hjelpeReferanseRettBak = hjelpeReferanse;
      hjelpeReferanse = hjelpeReferanse.finnNeste();
    }
    if (hjelpeReferanseRettBak == null ) {
      /* Dette skjer om listen var tom fra fr. */
      frsteElement = new NavneElement(nyttNavn);
    } else {
      /* 
       * Dette skjer dersom det var minst ett element i listen fra
       * fr. hjelpeReferanseRettBak refererer n til det siste
       * elementet. 
       */
      hjelpeReferanseRettBak.settNeste(new NavneElement(nyttNavn));
    }
  }
  
  public boolean skEtterNavn(String skeTekst) {
    NavneElement hjelpeReferanse = frsteElement;    
    while (hjelpeReferanse != null) {
      if (hjelpeReferanse.finnNavn().equals(skeTekst)) return true;
      hjelpeReferanse = hjelpeReferanse.finnNeste();
    }
    return false;
  }
  
  /* 
   * Denne metoden sletter alle forekomster av den gitte teksten fra
   * listen. 
   */
  public void slettNavn(String navnSomSkalSlettes) {
    NavneElement hjelpeReferanse = frsteElement;
    NavneElement hjelpeReferanseRettBak = null;
    
    /* Vi starter med  iterere oss framover i listen. */
    while (hjelpeReferanse != null) {
      if (hjelpeReferanse.finnNavn().equals(navnSomSkalSlettes)) {
	/* 
	 * Hjelpereferanse refererer n til et element som skal
	 * slettes. Vi m ha spesialbehandling dersom dette er det
	 * frste elementet i listen. 
	 */
	if (hjelpeReferanseRettBak != null) {
	  hjelpeReferanseRettBak.settNeste(hjelpeReferanse.finnNeste());
	} else {
	  frsteElement = hjelpeReferanse.finnNeste();
	}
	hjelpeReferanse = hjelpeReferanse.finnNeste();
      } else {
	hjelpeReferanseRettBak = hjelpeReferanse;
	hjelpeReferanse = hjelpeReferanse.finnNeste();
      }
    } 
  }
}
