/*
 * SubTre.java VBH 2000-02-25
 *
 * Klasse for delene av et binrt sketre. Subtrrne, inklusive
 * bladene, bestr av nye objekter av klassen.
 *
 */

class SubTre {
  private SubTre hyreTre = null;
  private SubTre venstreTre = null;
  private SubTre forelder = null;
  private int verdi = 0;

  public SubTre(int startVerdi) {
    verdi = startVerdi;
  }

  public SubTre(int startVerdi, SubTre startForelder) {
    verdi = startVerdi;
    forelder = startForelder;
  }

  /*
   * Metoden setter inn en ny verdi i dette (sub)treet.
   */
  public void settInnVerdi(int nyVerdi) {

    /* Dersom verdien for dette hjrnet er strre enn eller likden
     * nye, skal den nye verdien inn i venstre subtre. */
    if (verdi >= nyVerdi) {
      if (venstreTre != null) {
        venstreTre.settInnVerdi(nyVerdi);
      } else {
        venstreTre = new SubTre(nyVerdi, this);
      }
    } else {
      if (hyreTre != null) {
        hyreTre.settInnVerdi(nyVerdi);
      } else {
        hyreTre = new SubTre(nyVerdi, this);
      }
    }
  }

  /*
   * Metoden traverserer treet infiks og returnerer en tekst med
   * innholdet, separert med blanktegn.
   */
  public String toString () {
    String returStreng = "";
    if (venstreTre != null) {
      returStreng = venstreTre.toString() + " ";
    }
    returStreng = returStreng + verdi;
    if (hyreTre != null) {
      returStreng = returStreng + " " + hyreTre.toString();
    }
    return returStreng;
  }

  /*
   * Metoden returnerer true dersom den oppgitte verdien finnes i
   * treet.
   */
  public boolean skEtterVerdi(int skeVerdi) {
    if (skeVerdi == verdi) return true;
    if (verdi > skeVerdi) {
      if (venstreTre != null) {
  return venstreTre.skEtterVerdi(skeVerdi);
      } else {
  return false;
      }
    } else {
      if (hyreTre != null) {
  return hyreTre.skEtterVerdi(skeVerdi);
      } else {
  return false;
      }
    }
  }
}



