/*
 * SocketKlient.java  E.L.  2004-03-30
 *
 * Programmet kontakter et tjenerprogram som allerede kjrer p port 1250.
 * Linjer med tekst sendes til tjenerprogrammet. Det er laget slik at
 * det sender disse tekstene tilbake.
 */

import java.io.*;
import java.net.*;

class SocketKlient {
  public static void main(String[] args) throws IOException {
    final int portnr = 1250;

    /* pner forbindelse slik at inndata kan leses fra konsollet */
    InputStreamReader leseforbTilKonsoll = new InputStreamReader(System.in);
    BufferedReader leserFraKonsoll = new BufferedReader(leseforbTilKonsoll);

    /* Leser navn p tjenermaskin fra konsoll (se kapittel 12.7) */
    System.out.print("Oppgi navnet p maskinen der tjenerprogrammet kjrer: ");
    String tjenermaskin = leserFraKonsoll.readLine();

    /* Setter opp forbindelsen til tjenerprogrammet */
    Socket forbindelse = new Socket(tjenermaskin, portnr);
    System.out.println("N er forbindelsen opprettet.");

    /* pner strmmer for kommunikasjon med tjenerprogrammet */
    InputStreamReader leseforbindelse
                      = new InputStreamReader(forbindelse.getInputStream());
    BufferedReader leseren = new BufferedReader(leseforbindelse);
    PrintWriter skriveren = new PrintWriter(forbindelse.getOutputStream(), true);

    /* Leser innledning fra tjeneren og skriver den til konsollet */
    String innledning1 = leseren.readLine();
    String innledning2 = leseren.readLine();
    System.out.println(innledning1 + "\n" + innledning2);

    /* Leser tekst fra konsoll (brukeren) */
    String enLinje = leserFraKonsoll.readLine();
    while (!enLinje.equals("")) {
      skriveren.println(enLinje);  // sender teksten til tjeneren
      String respons = leseren.readLine();  // mottar respons fra tjeneren
      System.out.println("Fra tjenerprogrammet: " + respons);
      enLinje = leserFraKonsoll.readLine();
    }

    /* Lukker forbindelsen */
    leseren.close();
    skriveren.close();
    forbindelse.close();
  }
}

/* Utskrift p klientsiden:
Oppgi navnet p maskinen der tjenerprogrammet kjrer: tonje.aitel.hist.no
N er forbindelsen opprettet.
Hei, du har kontakt med tjenersiden!
Skriv hva du vil, s skal jeg gjenta det, avslutt med linjeskift.
Hallo, dette er en prove.
Fra tjenerprogrammet: Du skrev: Hallo, dette er en prve.
Og det fungerer utmerket.
Fra tjenerprogrammet: Du skrev: Og det fungerer utmerket.
*/