/*
 * TellerKlient.java   E.L. 2004-03-30
 *
 * Dette er hovedprogrammet p klientsiden.
 * Kontakt med tjeneren opprettes og tilbakekallsobjekt (klientobjekt) lages.
 */

import static javax.swing.JOptionPane.*;
import java.rmi.Naming;
class TellerKlient {
  public static void main(String[] args) throws Exception {
    String objektnavn = "ses_tellebyr_AS";
    String maskinnavn = showInputDialog(null, "Navn p tjenermaskin:");
    String url = "rmi://" + maskinnavn + "/" + objektnavn;

    /* Henter et stubb-objekt som vi kan bruke til  kommunisere med tjeneren */
    TellemaskinFront tellemaskin = (TellemaskinFront) Naming.lookup(url);

    String klientnavn = showInputDialog(null, "Oppgi klientnavn:");
    System.out.println("Her er konsollvinduet til " + klientnavn);

    /* Vi fr vinduet p plass. */
    TelleVindu vindu = new TelleVindu(tellemaskin, klientnavn);
    vindu.setVisible(true);

    /* Lager objekt som kan motta meldinger fra tjenersiden */
    Klient denneKlienten = new KlientImpl(klientnavn, vindu);

    /* Vi registrerer oss hos tjeneren. */
    tellemaskin.registrerMeg(denneKlienten);
  }
}