/*
 * DatabaseKontakt.java   E.L. 2005-03-16
 *
 * Programmet kopler seg til en database, og henter ut innholdet i tabellen Person.
 * SQL-skript for  lage tabellen Person er gjengitt nederst i denne filen.
 *
 * Stien til databasedriveren er satt opp i CLASSPATH. Dersom driveren er en
 * zip- eller jar-fil, m bde sti og filnavn inn i CLASSPATH.
 */

import static javax.swing.JOptionPane.*;
import java.sql.*;
class DatabaseKontakt {
  public static void main(String[] args) throws Exception {

    /* Hvis du bruker en annen driver, m du skifte ut strengkonstanten i neste linje. */
    String databasedriver = "oracle.jdbc.driver.OracleDriver";
    Class.forName(databasedriver);  // laster inn driverklassen

    /*
     * Vr Oracle-database heter orcl (standardnavnet), og den kjrer p maskinen
     * baron.stud.idb.hist.no. Strengkonstanten i neste linje m du
     * tilpasse din situasjon.
     */
    String databasenavn = "jdbc:oracle:thin:@oracle.stud.aitel.hist.no:1521:oracle";

    /* Leser inn brukernavn og passord */
    String brukernavn = showInputDialog("Brukernavn: ");
    String passord = showInputDialog("Passord: ");

    Connection forbindelse
      = DriverManager.getConnection(databasenavn, brukernavn, passord);

    Statement setning = forbindelse.createStatement();

    ResultSet res = setning.executeQuery("select * from person");
    while (res.next()) {
      int persNr = res.getInt("persnr");
      String fornavn = res.getString("fornavn");
      String etternavn = res.getString("etternavn");
      System.out.println(persNr + ": " + fornavn + " " + etternavn);
    }
    res.close();
    setning.close();
    forbindelse.close();
  }
}

/*
SQL-skript for  lage tabellen Person:

create table person(
 persnr    integer primary key,
 fornavn   varchar(30) not null,
 etternavn varchar(30) not null);

insert into person values (100, 'OLE', 'HANSEN');
insert into person values (101, 'ANNE GRETHE', 'S');
insert into person values (102, 'JONNY', 'HANSEN');

Utskrift fra programmet:

100: OLE HANSEN
101: ANNE GRETHE S
102: JONNY HANSEN
*/