/*
 * Transaksjonstest.java   E.L. 2004-04-01
 *
 * Programmet utfrer en databasetransaksjon som bestr av to SQL-setninger.
 */

import java.sql.*;
import static javax.swing.JOptionPane.*;
class Transaksjonstest {
  public static void main(String[] args) throws Exception {
    String databasedriver = "oracle.jdbc.driver.OracleDriver";
    Class.forName(databasedriver);
    String brukernavn = showInputDialog("Brukernavn: ");
    String passord = showInputDialog("Passord: ");
    String databasenavn = "jdbc:oracle:thin:@baron.stud.idb.hist.no:1521:orcl";
    Connection forbindelse =
       DriverManager.getConnection(databasenavn, brukernavn, passord);
    Statement setning = forbindelse.createStatement();

    /*
     * Transaksjon start
     */
    forbindelse.setAutoCommit(false);
    ResultSet res = setning.executeQuery("select * from konto");
    System.out.println("Innhold i databasen fr endring: ");
    while (res.next()) {
      System.out.println(res.getString("kontonr") + ", "
        + res.getString("navn") + ", " + res.getBigDecimal("saldo"));
    }
    res.close();

    /* Overfrer 1000 kroner fra konto 123456 til konto 678909 */
    setning.executeUpdate(
      "update konto set saldo = saldo - 1000 where kontonr = '123456'");
    setning.executeUpdate(
      "update konto set saldo = saldo + 1000 where kontonr = '678909'");

    /* Skriver ut alle dataene */
    res = setning.executeQuery("select * from konto");
    System.out.println("\nInnhold i databasen etter endring: ");
    while (res.next()) {
      System.out.println(res.getString("kontonr") + ", "
        + res.getString("navn") + ", " + res.getBigDecimal("saldo"));
    }
    res.close();

    /*
     * Transaksjon slutt
     */
    forbindelse.commit();
    forbindelse.setAutoCommit(true);
    setning.close();
    forbindelse.close();
  }
}

/* Utskrift fra programmet:

Innhold i databasen fr endring:
123456, OLE S, 1000
345678, ANNE GRETHE S, 20000
678909, JONNY HANSEN, 10000

Innhold i databasen etter endring:
123456, OLE S, 0
345678, ANNE GRETHE S, 20000
678909, JONNY HANSEN, 11000

*/