/*
 * JUnitNavneListeTest.java VBH 2002-10-08
 *
 * JUnit-test for klassen NavneListe
 *
 */

import junit.framework.*;

public class JUnitNavneListeTest extends TestCase {

  private NavneListe testListe;

  /*
   * Det lages en ny liste fr hver testmetode i denne testen.
   */
  protected void setUp() {
    testListe = new NavneListe();
  }

  /*
   * Etter hver testmetode setter vi listeobjektet til null. Det er
   * undvendig fordi vi lager et nytt i setUp(), men det gjr
   * koden noe klarere med tanke p at vi vil jobbe med et helt nytt objekt hver
   * gang.
   */
  protected void tearDown() {
    testListe = null;
  }

  public void testInnsetting() {
    testListe.settInnNavnTilSlutt("Truls");
    testListe.settInnNavnTilSlutt("Arne");
    testListe.settInnNavnTilSlutt("Sigvart");
    testListe.settInnNavnTilSlutt("Jonas");
    testListe.settInnNavnTilSlutt("Thomas");
    testListe.settInnNavnTilSlutt("Oddgeir");
    testListe.settInnNavnTilSlutt("Erlend");
    String listeTekst = testListe.toString();
    assertTrue(listeTekst.equals
      ("Truls\nArne\nSigvart\nJonas\nThomas\nOddgeir\nErlend\n"));
  }

  public void testSk() {
    testListe.settInnNavnTilSlutt("Linda");
    testListe.settInnNavnTilSlutt("Trine");
    testListe.settInnNavnTilSlutt("Kari");
    testListe.settInnNavnTilSlutt("Sara");
    testListe.settInnNavnTilSlutt("Wenche");
    testListe.settInnNavnTilSlutt("Hege");
    testListe.settInnNavnTilSlutt("Lise");
    /* Vi verifiserer at samtlige navn er med: */
    assertTrue(testListe.skEtterNavn("Linda"));
    assertTrue(testListe.skEtterNavn("Trine"));
    assertTrue(testListe.skEtterNavn("Kari"));
    assertTrue(testListe.skEtterNavn("Sara"));
    assertTrue(testListe.skEtterNavn("Wenche"));
    assertTrue(testListe.skEtterNavn("Hege"));
    assertTrue(testListe.skEtterNavn("Lise"));
    /* S sjekker vi noen strenger som ikke skal vre i listen: */
    assertFalse(testListe.skEtterNavn(null));
    assertFalse(testListe.skEtterNavn(""));
    assertFalse(testListe.skEtterNavn("lise"));
    assertFalse(testListe.skEtterNavn("hege"));
    assertFalse(testListe.skEtterNavn("LindaTrine"));
  }

  public void testSletting() {
    testListe.settInnNavnTilSlutt("Truls");
    testListe.settInnNavnTilSlutt("Arne");
    testListe.settInnNavnTilSlutt("Sigvart");
    testListe.settInnNavnTilSlutt("Jonas");
    testListe.settInnNavnTilSlutt("Thomas");
    testListe.settInnNavnTilSlutt("Oddgeir");
    testListe.settInnNavnTilSlutt("Erlend");
    String listeTekst = testListe.toString();
    assertTrue(listeTekst.equals
      ("Truls\nArne\nSigvart\nJonas\nThomas\nOddgeir\nErlend\n"));
    testListe.slettNavn("Thomas");
    testListe.slettNavn("Arne");
    testListe.slettNavn("Truls");
    listeTekst = testListe.toString();
    assertTrue(listeTekst.equals("Sigvart\nJonas\nOddgeir\nErlend\n"));
  }

  /*
   * Denne klassemetoden gjr klassen "kjrbar" i JUnit-sammenheng.
   *
   */
  public static Test suite() {
    return new TestSuite(JUnitNavneListeTest.class);
  }

  public static void main(String[] args) {
    junit.textui.TestRunner.run(suite()); // tekstlig brukergrensesnitt
  }
}

/*
Utskrift:
...
Time: 0,03

OK (3 tests)
*/
