/*
 * FontDemo.java   E.L. 2004-02-10
 *
 * Filen inneholder tre klasser:
 * Vindu: Et vindu med en tegning
 * Tegning: En tegning som viser ulike skrifttyper
 * FontDemo: main()-metode som viser fram vinduet med tegningen
 */

import java.awt.*;  // klassene Font og Graphics
import javax.swing.*; // klassene JFrame og JPanel

class Vindu extends JFrame {
  public Vindu(String tittel) {
    setTitle(tittel);
    setSize(500, 250); // bredde, hyde
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    Tegning tegningen = new Tegning();
    add(tegningen);
  }
}

class Tegning extends JPanel {
  public void paintComponent(Graphics tegneflate) {
    super.paintComponent(tegneflate);
    tegneflate.drawString("Frst en tekst med standardfonten.", 40, 60);
    Font skrift = new Font("SansSerif", Font.BOLD, 16);
    tegneflate.setFont(skrift);
    tegneflate.drawString(
      "Dette er skrevet med skrifttype " + skrift.getName(), 40, 100);
    skrift = new Font("Monospaced", Font.ITALIC, 16);
    tegneflate.setFont(skrift);
    tegneflate.drawString(
      "Dette er skrevet med skrifttype " + skrift.getName(), 40, 140);
    skrift = new Font("Dialog", Font.BOLD + Font.ITALIC, 16);
    tegneflate.setFont(skrift);
    tegneflate.drawString(
      "Dette er skrevet med skrifttype " + skrift.getName(), 40, 180);
  }
}

class FontDemo {
  public static void main(String[] args) {
    Vindu etVindu = new Vindu("Ulike skrifttyper");
    etVindu.setVisible(true);
  }
}