/*
 * KontoTest.java  E.L. 2004-02-10
 *
 * Filen inneholder to klasser:
 * Konto: Beskriver en bankkonto med muligheter for innskudd og uttak
 * KontoTest: Lager et konto-objekt og foretar transaksjoner.
 */

class Konto {
  private long   kontonr;
  private String navn;
  private double saldo;

  public Konto(long startKontonr, String startNavn, double startSaldo) {
    kontonr = startKontonr;
    navn = startNavn;
    saldo = startSaldo;
  }

  public long finnKontonr() {
    return kontonr;
  }

  public String finnNavn() {
    return navn;
  }

  public double finnSaldo() {
    return saldo;
  }

  public void innskudd(double belp) {
    saldo = saldo + belp;
  }

  public void uttak(double belp) {
    saldo = saldo - belp;
  }
}

/*
 * Et enkelt program som tester klassen Konto.
 * Vi tester en klasse ved  opprette et (eller flere) objekt(er) av klassen.
 * Deretter henter vi ut dataene fra objektet og skriver disse ut,
 * slik at vi kan se at objektet virkelig inneholder de dataene
 * vi putter inn. S prver vi ut metoder som endrer datainnholdet,
 * og metoder som gjr beregninger.
 */
class KontoTest {
  public static void main(String[] args) {

    /* Trinn 1: Lager et objekt av klassen */
    /* Kontonummeret er long, derfor L etter tallet */
    Konto olesKonto = new Konto(123456676756L, "Ole Olsen", 2300.50);

    /* Trinn 2: Prver ut tilgangsmetodene */
    long kontonr = olesKonto.finnKontonr();
    String navn = olesKonto.finnNavn();
    double saldo = olesKonto.finnSaldo();
    System.out.println("Fr endring av dataene: \nKontonr: " + kontonr +
      ", navn: " + navn + ", saldo: " + saldo);

    /* Trinn 3: Prver mutasjonsmetodene */
    olesKonto.innskudd(1000);  // n er saldo lik 3300,50
    olesKonto.uttak(500);  // n er saldo lik 2800,50

    kontonr = olesKonto.finnKontonr();
    navn = olesKonto.finnNavn();
    saldo = olesKonto.finnSaldo();
    System.out.println("Etter endring av dataene: \nKontonr: " + kontonr +
      ", navn: " + navn + ", saldo: " + saldo);
  }
}
/* Kjring av programmet:
Fr endring av dataene:
Kontonr: 123456676756, navn: Ole Olsen, saldo: 2300.5
Etter endring av dataene:
Kontonr: 123456676756, navn: Ole Olsen, saldo: 2800.5
*/
