/*
 * MaanedTest.java   E.L. 2004-09-08
 *
 * Et eksempel p en enum-type med egen konstruktr og egne medlemmer.
 */

import static javax.swing.JOptionPane.*;

enum Maaned {
  januar(31), februar(28), mars(31), april(30), mai(31), juni(30), juli(31),
  august(31), september(30), oktober(31), november(30), desember(31);

  private int antDg;

  private Maaned(int startAntDg) {
    antDg = startAntDg;
  }

  public int finnAntDg() {
    return antDg;
  }
}

class MaanedTest {
  public static void main(String[] args) {

    /* Leser inn et mnedsnavn og finner antall dager i mneden */
    String mndLest = showInputDialog("Mnedsnavn: ");
    mndLest = mndLest.trim().toLowerCase();
    Maaned mnd = Maaned.valueOf(mndLest); // unntaksobjekt kastes hvis ugyldig navn
    int antDg = mnd.finnAntDg();
    showMessageDialog(null, "Mneden har " + antDg + " dager.");

    Maaned[] alleMnd = Maaned.values(); // en tabell med alle mnedene

    /* Leser inn et mnedsnummer og finner antall dager i mneden */
    mndLest = showInputDialog("Mnedsnr (1-12): ");
    int nr = Integer.parseInt(mndLest) - 1;
    if (nr >= 0 && nr < alleMnd.length) { // gyldig verdi
      mnd = alleMnd[nr];
      antDg = mnd.finnAntDg();
      showMessageDialog(null, "Mneden er " + mnd + ", og den har " + antDg + " dager.");
    } else showMessageDialog(null, "Ugyldig mnedsnummer.");
  }
}

/* Eksempeldata:
Mnedsnavn: Mai
Mneden har 31 dager.
Mnednr (1-12): 3
Mneden er mars, og den har 31 dager.
*/
