/*
 * Prisberegning.java   E.L. 2004-02-10
 *
 * Filen inneholder to klasser:
 * Vare: Klassen beskriver varer med navn, nummer og pris. Det er
 * mulig  beregne prisen for et gitt antall kilo, med og uten moms.
 * Prisberegning: Oppretter to vareobjekter og beregner prisen med
 * og uten moms for et gitt kvantum.
 *
 * Programmet brukes i vingsoppgaver i kapittel 4.
 */

class Vare {
  private static final double moms = 24.0;
  private static final double momsfaktor = 1.0 + moms / 100.0;

  private String varenavn;
  private int varenr;
  private double pris; // pris pr kilo, alltid uten moms

  public Vare(String startVarenavn, int startVarenr, double startPris) {
    varenavn = startVarenavn;
    varenr = startVarenr;
    pris = startPris;
  }

  public Vare(String startVarenavn, int startVarenr) {
    varenavn = startVarenavn;
    varenr = startVarenr;
    pris = 0.0;
  }

  public double finnPrisUtenMoms(double antKilo) {
    return pris * antKilo;
  }

  public double finnPrisMedMoms(double antKilo) {
    return pris * antKilo * momsfaktor;
  }

  public void settPris(double nyPris) {
    pris = nyPris;
  }
}

class Prisberegning {
  public static void main(String[] args) {
    final java.text.NumberFormat pengeformat = java.text.NumberFormat.getCurrencyInstance();
    final double kvantum = 2.5;
    final double kilopris1 = 73.50;
    final double kilopris2 = 79.60;

    Vare enVare = new Vare("Norvegia", 124, kilopris1);
    double pris1 = enVare.finnPrisUtenMoms(kvantum);  // Henter ut en tallverdi
    double pris2 = enVare.finnPrisMedMoms(kvantum);
    String pris1Formatert = pengeformat.format(pris1);  // Formaterer
    String pris2Formatert = pengeformat.format(pris2);
    System.out.println("Prisen for " + kvantum + " kg er " + pris1Formatert + " uten moms.");
    System.out.println("Prisen for " + kvantum + " kg er " + pris2Formatert + " med moms.");

    enVare.settPris(kilopris2);
    /*
     * Her henter vi ut tallverdien, formaterer og bruker resultatet i et uttrykk
     * uten  g veien om hjelpevariabler, slik det ble gjort over.
     */
    System.out.println("Ny kilopris: " + pengeformat.format(kilopris2));
    System.out.println("Prisen for " + kvantum + " kg er "
        + pengeformat.format(enVare.finnPrisUtenMoms(kvantum)) + " uten moms.");
    System.out.println("Prisen for " + kvantum + " kg er "
        + pengeformat.format(enVare.finnPrisMedMoms(kvantum)) + " med moms.");
  }
}

/* Kjring av programmet:
Prisen for 2.5 kg er kr 183,75 uten moms.
Prisen for 2.5 kg er kr 227,85 med moms.
Ny kilopris: kr 79,60
Prisen for 2.5 kg er kr 199,00 uten moms.
Prisen for 2.5 kg er kr 246,76 med moms.
*/