/*
 * MittTallformatUt.java   E.L. 2002-07-19
 *
 * Klassen beskriver et desimalformat som egner seg til utskrift av tall
 * under hverandre i kolonner. Antall posisjoner fr og etter desimalkomma er parametre
 * i konstruktren.
 */

import java.text.*;
import java.util.*;

class MittTallformatUt {
  private DecimalFormat tallformat;

  public MittTallformatUt(int antPosFrKomma, int antPosEtterKomma) {
    char[] formatTegn = new char[antPosFrKomma + antPosEtterKomma + 1];
    Arrays.fill(formatTegn, '0');
    formatTegn[antPosFrKomma] = '.';
    tallformat = new DecimalFormat(new String(formatTegn));
  }

  public String format(double tall) { // kan ogs sende inn heltall som argument
    boolean fortegn = false;
    if (tall < 0) {  // Vi setter p fortegnet til slutt
      fortegn = true;
      tall = -tall;
    }

    String tekst = tallformat.format(tall);

    /* Bytter ut ledende nuller med blanke, men ikke siste foran komma */
    char[] tegnene = tekst.toCharArray();
    int pos = 0;
    while (pos < tegnene.length && tegnene[pos] == '0') {
      if (tegnene[pos + 1] != ',') tegnene[pos] = ' ';
      pos++;
    }

    String nyttFormat = new String(tegnene);
    if (fortegn) {
      if (pos > 0) {
        tegnene[pos - 1] = '-';
        nyttFormat = new String(tegnene);
      } else nyttFormat = "-" + nyttFormat;
    }
    return nyttFormat;
  }
  
  /* 
   * Klassen sin egen testklient. Du kan gjerne bruke denne klassen i main()-metoder i
   * andre klasser uten at du behver  ta bort den main() som er her. Nr du kjrer 
   * en klasse, er det alltid main() i den klassen som gjelder, uavhengig av om andre 
   * klasser som inngr i programmet har main()-metoder.
   */
  public static void main(String[] args) { 
    MittTallformatUt formatet = new MittTallformatUt(5, 2);
    String tallLest = javax.swing.JOptionPane.showInputDialog("Tall som skal skrives ut: ");
    double tall = Double.parseDouble(tallLest);
    for (int i = 0; i < 8; i++) {
      System.out.println(formatet.format(tall));
      tall *= 10;
    }
    System.exit(0);
  }
}

/* Eksempel-utskrift:
    8,50
   85,00
  850,00
 8500,00
85000,00
850000,00
8500000,00
85000000,00
*/