/*
 * TegnFlekkerMedLinjer.java   E.L. 2004-02-13
 *
 * Filen inneholder tre klasser:
 * Vindu: En tegneflate med en tegning
 * Tegning: En tegning med fylte sirkler med streker mellom
 * TegnFlekkerMedLinjer: main()-metode som viser fram vinduet med tegningen
 */

import java.awt.*;
import javax.swing.*;
import java.util.Random;

class Vindu extends JFrame {
  public Vindu(String tittel) {
    setTitle(tittel);
    setSize(400, 300); // bredde, hyde
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    Tegning tegningen = new Tegning();
    add(tegningen);
  }
}

class Tegning extends JPanel {
  private static final int diameter = 20;
  private static final int sentr = diameter / 2;
  private static final int antStreker = 10;
  private Random tallGen = new Random();
  private int maksXverdi;
  private int maksYverdi;

  public void paintComponent(Graphics tegneflate) {
    super.paintComponent(tegneflate);
    maksXverdi = getWidth() - 1;
    maksYverdi = getHeight() - 1;
    int x = tallGen.nextInt(maksXverdi - diameter);
    int y = tallGen.nextInt(maksYverdi - diameter);
    tegneflate.fillOval(x, y, diameter, diameter);
    int teller = 0;
    while (teller < antStreker) {
      int forrigeX = x;
      int forrigeY = y;
      x = tallGen.nextInt(maksXverdi - diameter);
      y = tallGen.nextInt(maksYverdi - diameter);
      tegneflate.drawLine(forrigeX + sentr, forrigeY + sentr, x + sentr, y + sentr);
      tegneflate.fillOval(x, y, diameter, diameter);
      teller++;
    }
  }
}

class TegnFlekkerMedLinjer {
  public static void main(String[] args) {
    Vindu etVindu = new Vindu("Flekker med linjer");
    etVindu.setVisible(true);
  }
}