/*
 * SalgMedMeny.java  E.L. 2004-08-09
 *
 * Filen inneholder tre klasser SalgBGS, Menyvalg og SalgMedMeny.
 * Klassene er kort beskrevet der de er deklarert.
 */

import static javax.swing.JOptionPane.*;
import mittBibliotek.DataLeser; // mittBibliotek m vre installert, se kapittel 6.9

/*
 * Klassen SalgBGS beskriver grensesnittet mellom et objekt av
 * klassen Salgstall og brukeren. Den tilbyr en metode for hvert enkelt menyvalg.
 */
class SalgBGS {
  private Salgstall salg;  // se programliste 7.5

  public SalgBGS(Salgstall startSalg) {
    salg = startSalg;
  }

  public void regSalg() {
    int uke = DataLeser.lesHeltall("Oppgi ukenr (min 1, maks " + salg.finnAntUker() + ")");
    int dag = DataLeser.lesHeltall("Oppgi dagnr (min 1, maks " + salg.finnAntDgPrUke() + ")");
    String melding = "Uke: " + uke + ", dag: " + dag + ": ";
    int salget = DataLeser.lesHeltall("Oppgi salg: ");
    if (salg.settSalg(uke - 1, dag - 1, salget)) melding += "Salg registrert, kr " + salget;
    else melding += "Salg ikke registrert, ugyldig dag eller uke.";
    showMessageDialog(null, melding);
  }

  public void finnSalg() {
    int uke = DataLeser.lesHeltall("Oppgi ukenr (min 1, maks " + salg.finnAntUker() + ")");
    int dag = DataLeser.lesHeltall("Oppgi dagnr (min 1, maks " + salg.finnAntDgPrUke() + ")");
    String melding = "Uke: " + uke + ", dag: " + dag + ": ";
    int salget = salg.finnSalg(uke - 1, dag - 1);
    if (salget >= 0) melding += "Salg denne dag kr " + salget;
    else melding += "Ugyldig dag eller uke.";
    showMessageDialog(null, melding);
  }

  public void finnSalgUke() {
    int uke = DataLeser.lesHeltall("Oppgi ukenr (min 1, maks " + salg.finnAntUker() + ")");
    int salget = salg.finnSalgForHelUke(uke - 1);
    String melding = "";
    if (salget >= 0) melding = "Salget uke " + uke + " var kr " + salget;
    else melding = "Ugyldig uke: " + uke;
    showMessageDialog(null, melding);
  }

  public void finnTotalsalg() {
    showMessageDialog(null, "Total salg kr " + salg.finnTotalsalg());
  }
}

/*
 * Menyvalg er en enum-klasse som beskriver de ulike menyvalgene.
 */
enum Menyvalg {
  valgRegSalg("Registrer nytt salg"),
  valgFinnSalg("Finn salg for dag"),
  valgFinnSalgUke("Finn salg for uke"),
  valgFinnTotalsalg("Finn totalsalg"),
  valgAvslutt("Avslutt");

  private String tekst;

  private Menyvalg(String startTekst) {
    tekst = startTekst;
  }

  /* Erstatter toString() arvet fra klassen Enum */
  public String toString() {
    return tekst;
  }

  /*
   * Lager en tabell med menyen som bestr av alle tekstene,
   * den skal inn i showOptionDialog()
   */
  public static String[] lagAltTab() {
    Menyvalg[] altTab = Menyvalg.values();
    String[] tabell = new String[altTab.length];
    for (int i = 0; i < altTab.length; i++) tabell[i] = altTab[i].toString();
    return tabell;
  }
}

/*
 * SalgMedMeny inneholder main(), som lar brukeren gjre menyvalg, og som
 * deretter srger for  gjennomfre disse ved  sende meldinger til et objekt
 * av klassen SalgBGS.
 */
class SalgMedMeny {
  public static void main(String[] args) {
    Salgstall salg = new Salgstall("mat", 4, 5);
    SalgBGS bgs = new SalgBGS(salg);

    String[] alternativer = Menyvalg.lagAltTab();
    boolean fortsett = true;
    int valgtVerdi = showOptionDialog(null, "Gjr et valg", "Salgstall",
               DEFAULT_OPTION, PLAIN_MESSAGE, null, alternativer, alternativer[0]);

    if (valgtVerdi == CLOSED_OPTION
        || valgtVerdi == Menyvalg.valgAvslutt.ordinal()) fortsett = false;
    while (fortsett) {
      Menyvalg valg = (Menyvalg.values()) [valgtVerdi];
      switch (valg) {

        case valgRegSalg:
          bgs.regSalg();
          break;

        case valgFinnSalg:
          bgs.finnSalg();
          break;

        case valgFinnSalgUke:
          bgs.finnSalgUke();
          break;

        case valgFinnTotalsalg:
          bgs.finnTotalsalg();
          break;

        default:
          break;
      }
      valgtVerdi = showOptionDialog(null, "Gjr et valg", "Salgstall",
               DEFAULT_OPTION, PLAIN_MESSAGE, null, alternativer, alternativer[0]);
      if (valgtVerdi == CLOSED_OPTION
              || valgtVerdi == Menyvalg.valgAvslutt.ordinal()) fortsett = false;
    }
  }
}

/* Eksempel p kjring, se figur 7.11 */