/*
 * SalgMedMenyUtenEnum.java  E.L. 2006-01-26
 *
 * Alternativ til klassen SalgMedMeny (side 268), men uten bruke av enum
 *
 * Filen inneholder to klasser:
 *
 * SalgBGS: Klassen beskriver grensesnittet mellom et objekt av
 * klassen Salgstall og brukeren. Den tilbyr en metode for hvert enkelt menyvalg.
 *
 * SalgMedMeny: Inneholder main(), som lar brukeren gjre menyvalg, og som
 * deretter srger for  gjennomfre disse ved  sende meldinger til et objekt
 * av klassen SalgBGS.
 */

import static javax.swing.JOptionPane.*;
import mittBibliotek.DataLeser; // mittBibliotek m vre installert, se kapittel 6.9

class SalgBGS {
  private Salgstall salg;  // se programliste 7.5

  public SalgBGS(Salgstall startSalg) {
    salg = startSalg;
  }

  public void regSalg() {
    int uke = DataLeser.lesHeltall(
                  "Oppgi ukenr (min 1, maks " + salg.finnAntUker() + ")");
    int dag = DataLeser.lesHeltall(
                  "Oppgi dagnr (min 1, maks " + salg.finnAntDgPrUke() + ")");
    String melding = "Uke: " + uke + ", dag: " + dag + ": ";
    int salget = DataLeser.lesHeltall("Oppgi salg: ");
    if (salg.settSalg(uke - 1, dag - 1, salget)) melding += "Salg registrert, kr " + salget;
    else melding += "Salg ikke registrert, ugyldig dag eller uke.";
    showMessageDialog(null, melding);
  }

  public void finnSalg() {
    int uke = DataLeser.lesHeltall(
              "Oppgi ukenr (min 1, maks " + salg.finnAntUker() + ")");
    int dag = DataLeser.lesHeltall(
              "Oppgi dagnr (min 1, maks " + salg.finnAntDgPrUke() + ")");
    String melding = "Uke: " + uke + ", dag: " + dag + ": ";
    int salget = salg.finnSalg(uke - 1, dag - 1);
    if (salget >= 0) melding += "Salg denne dag kr " + salget;
    else melding += "Ugyldig dag eller uke.";
    showMessageDialog(null, melding);
  }

  public void finnSalgUke() {
    int uke = DataLeser.lesHeltall(
              "Oppgi ukenr (min 1, maks " + salg.finnAntUker() + ")");
    int salget = salg.finnSalgForHelUke(uke - 1);
    String melding = "";
    if (salget >= 0) melding = "Salget uke " + uke + " var kr " + salget;
    else melding = "Ugyldig uke: " + uke;
    showMessageDialog(null, melding);
  }

  public void finnTotalsalg() {
    showMessageDialog(null, "Total salg kr " + salg.finnTotalsalg());
  }
}

class SalgMedMenyUtenEnum {
  public static void main(String[] args) {
    final String[] alternativer = {"Registrer nytt salg",
    "Finn salg for dag", "Finn salg for uke", "Finn totalsalg", "Avslutt"};
    final int valgRegSalg = 0;   // tallverdiene svarer til indeksen i
    final int valgFinnSalg = 1;  // tabellen over
    final int valgFinnSalgUke = 2;
    final int valgFinnTotalsalg = 3;
    final int valgAvslutt = 4;

    Salgstall salg = new Salgstall("mat", 4, 5);
    SalgBGS bgs = new SalgBGS(salg);

    int valg = showOptionDialog(null, "Gjr et valg", "Salgstall",  DEFAULT_OPTION,
                      PLAIN_MESSAGE, null, alternativer, alternativer[0]);
    while (valg != valgAvslutt && valg != CLOSED_OPTION) {
      switch (valg) {

        case valgRegSalg:
          bgs.regSalg();
          break;

        case valgFinnSalg:
          bgs.finnSalg();
          break;

        case valgFinnSalgUke:
          bgs.finnSalgUke();
          break;

        case valgFinnTotalsalg:
          bgs.finnTotalsalg();
          break;

        default:
          break;
      }
      valg = showOptionDialog(null, "Gjr et valg", "Salgstall", DEFAULT_OPTION, PLAIN_MESSAGE, null,
                                                       alternativer, alternativer[0]);
    }
  }
}