/*
 * Belegg.java   E.L. 2004-04-03
 *
 * Klassen Belegg tilbyr metoder for beregning av materialbehov og pris.
 * For  f til dette m et objekt av klassen samarbeide med
 * et objekt av klassen Flate, se programliste 8.5.
 */

class Belegg {
  private static final double grense = 0.02; // grense for  beregne en bredde ekstra

  private String navn;  // identifiserer belegget
  private double pris;  // pris pr. meter
  private double breddePBelegg;    // meter

  public Belegg(String startNavn, double startPris, double startBredde) {
    navn = startNavn;
    pris = startPris;
    breddePBelegg = startBredde;
  }

  public String finnNavn() {
    return navn;
  }

  public double finnPrisPrM() {
    return pris;
  }

  public double finnBredde() {
    return breddePBelegg;
  }

  /*
   * Skal beregne antall meter som trengs til en flate.
   * Teppet legges alltid p tvers av golvets lengde.
   * For  finne ut om det er billigere  legge teppet andre veien,
   * m klienten bytte om lengde og bredde i den flaten som
   * sendes inn som argument.
   */
  public double finnAntMeter(Flate enFlate) {
    double lengdeFlate = enFlate.finnLengde();
    double breddeFlate = enFlate.finnBredde();

    int antBredder = (int)(lengdeFlate / breddePBelegg);
    double rest = lengdeFlate % breddePBelegg;
    if (rest >= grense) antBredder++;
    return antBredder * breddeFlate;
  }

  public double finnTotalpris(Flate enFlate) {
    return finnAntMeter(enFlate) * pris;
  }

  public String toString() {
    java.text.DecimalFormat utskriftFormat = new java.text.DecimalFormat("####0.00");
    return "Belegg: " + navn + ", pris kr " + utskriftFormat.format(pris)
          + " pr. m, bredde: " + utskriftFormat.format(breddePBelegg) + " m.";
  }
}