/*
 * Tapet.java   E.L. 2002-09-04
 *
 * Klassen Tapet tilbyr metoder for beregning av materialbehov og pris.
 *
 */
import java.text.DecimalFormat;
class Tapet {
  private static final double grense = 0.02; // grense for  beregne en rull ekstra
  private String navn;   // identifiserer tapeten
  private double pris;   // pris pr. rull
  private double lengdePrRull;    // meter
  private double breddePrRull;    // meter

  public Tapet(String startNavn, double startPris, double startLengde, double startBredde) {
    navn = startNavn;
    pris = startPris;
    lengdePrRull = startLengde;
    breddePrRull = startBredde;
  }

  public String finnNavn() {
    return navn;
  }

  public double finnPrisPrRull() {
    return pris;
  }

  public double finnLengde() {
    return lengdePrRull;
  }

  public double finnBredde() {
    return breddePrRull;
  }

  /*
   * Metoden finner totalt antall ruller som trengs for  tapetsere en flate.
   */
  public int finnAntRuller(Flate enFlate) {
    double lengdeFlate = enFlate.finnLengde();
    double hydeFlate = enFlate.finnBredde();

    /* finner antall hyder vi trenger: */
    int antHyder = (int) (lengdeFlate / breddePrRull);
    double rest = lengdeFlate % breddePrRull;
    if (rest >= grense) antHyder++;

    /* finner antall ruller som trengs */
    int antRuller;
    int antHyderPrRull = (int) (lengdePrRull / hydeFlate);
    if (antHyderPrRull > 0) {
      antRuller = antHyder / antHyderPrRull;
      rest = antHyder % antHyderPrRull;
      if (rest >= grense) antRuller++;
    } else {  // rullen er for kort til  dekke en hyde (sjelden!)
      double totAntMeter = antHyder * hydeFlate;
      antRuller = (int) (totAntMeter / lengdePrRull);
      if (totAntMeter % lengdePrRull >= grense) antRuller++;
    }
    return antRuller;
  }

  public double finnTotalpris(Flate enFlate) {
    return finnAntRuller(enFlate) * pris;
  }

  public String toString() {
    java.text.DecimalFormat utskriftFormat = new java.text.DecimalFormat("####0.00");
    return "Tapet: " + navn + ", pris kr. " + utskriftFormat.format(pris) +
           " pr. rull, lengde rull: " + utskriftFormat.format(lengdePrRull) +
           " m, bredde rull: " + utskriftFormat.format(breddePrRull) + " m";
  }
}