/*
 * TestStudent3.java    E.L. 2004-03-20
 *
 * Klienten fr bruke klassen Navn, men studentobjektet har sin egen kopi.
 * Denne kopien har ingen utenfor objektet tilgang til. Dette er en
 * komposisjon. (Men - obs vi kopierer ikke strengene som er en del
 * av navneobjektet, se teksten for nrmere forklaring.)
 */

class Student {
  private Navn navn;
  private int fdato;

  public Student(Navn startNavn, int startFdato) {
    /* Vi lar studentobjektet f sin egen kopi av navneobjektet */
    String startFornavn = startNavn.finnFornavn();
    String startEtternavn = startNavn.finnEtternavn();
    navn = new Navn(startFornavn, startEtternavn);
    fdato = startFdato;
  }

  public int finnFdato() {
    return fdato;
  }

  public Navn finnNavn() {
    /* Returnerer en kopi */
    return new Navn(navn.finnFornavn(), navn.finnEtternavn());
  }

  public void settNavn(Navn nyttNavn) {
    /* Vi lager en kopi av det navneobjektet som kommer inn */
    String nyttFornavn = nyttNavn.finnFornavn();
    String nyttEtternavn = nyttNavn.finnEtternavn();
    navn.settFornavn(nyttFornavn);
    navn.settEtternavn(nyttEtternavn);
  }

  public String toString() {
    return navn + ", fdt: " + fdato;
  }
}

class TestStudent3 {

  /*
   * Fokuserer p  vise at et studentobjekt har sitt eget navneobjekt,
   * som klienten ikke har tilgang til.
   */
  public static void main(String[] args) {
    /* Oppretter et navneobjekt som er argument til Student-konstruktren */
    Navn studNavn = new Navn("Ole Andreas", "Thomassen");
    Student studenten = new Student(studNavn, 19801010);

    /* Kontrollerer at navnet ble rett registrert. */
    System.out.println("A: Student " + studenten.toString());

    /* Endrer klienten sitt navneobjekt */
    studNavn.settFornavn("Ingolf");

    /* Studentobjektet skal ikke vre endret */
    System.out.println("B: Student " + studenten.toString());

    /* Klienten henter ut (sin egen kopi av) studentobjektets navn */
    Navn mittNavn = studenten.finnNavn();
    mittNavn.settFornavn("Kre");  // endrer klientens kopi
    System.out.println("C: Student " + studenten.toString());

    /* Endrer studentobjektets navn */
    studenten.settNavn(new Navn("Ole Andreas", "Haug"));
    System.out.println("D: Student " + studenten.toString());
  }
}

/* Kjring av programmet:
A: Student Ole Andreas Thomassen, fdt: 19801010
B: Student Ole Andreas Thomassen, fdt: 19801010
C: Student Ole Andreas Thomassen, fdt: 19801010
D: Student Ole Andreas Haug, fdt: 19801010
*/