/*
 * TabellListeAvFag.java  E.L. 2004-02-15
 *
 * Dette er en revidert utgave av programliste 7.9.
 *
 * Programliste 7.9 bruker en tabell til  lagre fagobjekter.
 * Her bruker vi en tabell-liste (et objekt av klassen ArrayList).
 * Fordelen er at vi ikke trenger  tenke p at tabellen gr full.
 * Kommentarene nedenfor fokuserer p forskjellene mellom dette
 * programmet og programliste 7.9.
 */

import java.util.ArrayList;
import static javax.swing.JOptionPane.*;

/* Klassen Fag er den samme som i programliste 7.9 */
class Fag {
  private String fagkode;  // entydig
  private String fagnavn;
  private int antSp;  // antall studiepoeng

  public Fag(String startFagkode, String startFagnavn, int startAntStudiepoeng) {
    fagkode = startFagkode;
    fagnavn = startFagnavn;
    antSp = startAntStudiepoeng;
  }

  public String finnFagkode() {
    return fagkode;
  }

  public String finnFagnavn() {
    return fagnavn;
  }

  public int finnAntStudiepoeng() {
    return antSp;
  }

  public String toString() {
    return "Kode: " + fagkode + ", Navn: " + fagnavn + ", " + antSp + " studiepoeng.";
  }
}

class Fagkatalog {

  /*
   * Et objekt av klassen ArrayList<Fag> i stedet for tabell og antFag-teller.
   * Vi trenger ikke  lage noen konstruktr. Standardkonstruktren er god nok.
   */
  private ArrayList<Fag> fagene = new ArrayList<Fag>();

  /* En tabell-liste kan ikke bli full, derfor er retur-type void ok */
  public void registrerNyttFag(String startFagkode,
                String startFagnavn, int startAntStudiepoeng) {
    Fag nyttFag = new Fag(startFagkode, startFagnavn, startAntStudiepoeng);
    fagene.add(nyttFag);
  }

  /* Tabell-listen vet selv hvor mange referanser som er lagret der */
  public int finnAntallFag() {
    return fagene.size();
  }

  /* En m passe p indeksen ogs nr en bruker tabell-liste */
  public Fag finnFag(int indeks) {
    if (indeks >= 0 && indeks < fagene.size()) {
      return fagene.get(indeks);
    } else return null;
  }

  /*
   * Sortering etter samme algoritme som fr: Sortering ved utvelging.
   * Vi bruker get() for  se p et element i tabell-listen og
   * set() for  sette et element inn p en bestemt plass i listen
   */
  public void sorterFag() {
    for (int start = 0; start < fagene.size(); start++) {
      int hittilMinst = start;
      for (int i = start + 1; i < fagene.size(); i++) {
        Fag detteFag = fagene.get(i);
        String denneFagkode = detteFag.finnFagkode();
        Fag hittilMinstFag = fagene.get(hittilMinst);
        String hittilMinstFagkode = hittilMinstFag.finnFagkode();
        if (denneFagkode.compareToIgnoreCase(hittilMinstFagkode) < 0) hittilMinst = i;
      }
      Fag hjelp = fagene.get(hittilMinst);
      Fag fagStart = fagene.get(start);
      fagene.set(hittilMinst, fagStart);
      fagene.set(start, hjelp);
    }
  }

  public String toString() {
    String resultat = "";
    for (Fag etFag : fagene) resultat += etFag.toString() + "\n";
    return resultat;
  }
}

class TabellListeAvFag {

  public static void main(String[] args) {
    /* Eneste forskjell fra programliste 7.9 er bruk av konstruktren */
    Fagkatalog katalogen = new Fagkatalog();

    boolean ok = true;
    String kode = showInputDialog("Fagkode (avslutt med blank): ");
    while (ok && !kode.trim().equals("")) {
      String navn = showInputDialog("Fagnavn: ");
      String spLest = showInputDialog("Antall studiepoeng: ");
      int sp = Integer.parseInt(spLest.trim());

      katalogen.registrerNyttFag(kode.trim(), navn.trim(), sp);
      showMessageDialog(null, "Registrering ok");
      kode = showInputDialog("Fagkode (avslutt med blank): ");
    }

    /* Usortert liste, prver finnAntFag() og finnFag() */
    String utskrift = "";
    for (int i = 0; i < katalogen.finnAntallFag(); i++) {
      utskrift += katalogen.finnFag(i).toString() + "\n";
    }
    showMessageDialog(null, "Usortert:\n" + utskrift);
    katalogen.sorterFag();

    /* Sortert liste, prver toString() */
    showMessageDialog(null, "Sortert:\n" + katalogen.toString());

    System.exit(0);
  }
}

/* Eksempeldata, ferdig sortert:
Kode: LV172D, Navn: Programmering i Java, 6 studiepoeng.
Kode: LV191D, Navn: Videregende programmering, 6 studiepoeng.
Kode: LV193D, Navn: Web-programmering med JSP, 6 studiepoeng.
Kode: LV195D, Navn: Objektorientert programmering i C++, 12 studiepoeng.
*/