/*
 * TestSorterTekstTabell.java  E.L. 2004-02-15
 *
 * Bruker metoder med kollatorer til sortering og sking.
 * Kompilatoren gir advarsler p grunn av at klassen Collator ikke
 * angir typebetegnelse i sin implementasjon av Comparator. Dette
 * er det ikke ndvendig  ta hensyn til.
 */

import java.util.Arrays;
import java.text.Collator;
class TestSorterTekstTabell {
  public static void main(String[] args) {
    String[] navneliste = {"Ole", "Per", "se", "Kari", "Kari Beate",
                                           "Toril", "yvind", "sop"};
    Collator koll = Collator.getInstance();
    Arrays.sort(navneliste, koll);

    System.out.println("Sortert navneliste:");
    for (String navn : navneliste) System.out.println(navn);

    /* Binrsk krever at dataene er sortert */
    int res1 = Arrays.binarySearch(navneliste, "sop", koll); // finnes
    System.out.println("Fant \"sop\" p indeks " + res1);

    int res2 = Arrays.binarySearch(navneliste, "Lise", koll); // finnes ikke
    System.out.println("\"Lise\" skal plasseres p indeks " + (- res2 - 1));
  }
}

/* Utskrift:
Sortert navneliste:
Kari
Kari Beate
Ole
Per
Toril
sop
yvind
se
Fant "sop" p indeks 5
"Lise" skal plasseres p indeks 2
*/
