/*
 * Vare.java   E.L. 2002-09-20
 * Trengs i vingsoppgaver, kap. 7 og 9.
 *
 */
class Vare {
  private static final double moms = 24.0;
  private static final double momsfaktor = 1.0 + moms / 100.0;

  private String varenavn;
  private int varenr;
  private double pris; // pris pr kilo, alltid uten moms

  public Vare(String startVarenavn, int startVarenr, double startPris) {
    varenavn = startVarenavn;
    varenr = startVarenr;
    pris = startPris;
  }

  public Vare(String startVarenavn, int startVarenr) {
    varenavn = startVarenavn;
    varenr = startVarenr;
    pris = 0.0;
  }

  public String finnNavn() {
    return varenavn;
  }

  public int finnVarenr() {
    return varenr;
  }

  public double finnPris() { // pr enhet, uten moms
    return pris;
  }

  public double finnPrisUtenMoms(double antKilo) {
    return pris * antKilo;
  }

  public double finnPrisMedMoms(double antKilo) {
    return pris * antKilo * momsfaktor;
  }

  public void settPris(double nyPris) { // pr enhet, uten moms
    pris = nyPris;
  }
}