/*
 * Flate.java   E.L. 2004-04-03
 *
 * Klassen Flate tilbyr metoder for beregning av areal og omkrets.
 * Utvidet med referanse til malingstype (kapittel 9).  Dette er
 * implementasjonen av assosiasjonen "bruker" p figur 9.3.
 */

class Flate {
  private String navn;  // til identifikasjon
  private double lengde;
  private double bredde;
  private Maling malingstype;

  public Flate(String startNavn, double startLengde, double startBredde) {
    navn = startNavn;
    lengde = startLengde;
    bredde = startBredde;
  }

  public void settMaling(Maling nyMalingstype) {
    malingstype = nyMalingstype;
  }

  public Maling finnMaling() {
    return malingstype;
  }

  public String finnNavn() {
    return navn;
  }

  public double finnLengde() {
    return lengde;
  }

  public double finnBredde() {
    return bredde;
  }

  public double finnAreal() {
    return bredde * lengde;
  }

  public double finnOmkrets() {
    return 2 * (lengde + bredde);
  }

  public String toString() {
    java.text.DecimalFormat utskriftFormat = new java.text.DecimalFormat("####0.00");
    return "Flate: " + navn + ", bredde: " + utskriftFormat.format(bredde) +
           " m, lengde: " + utskriftFormat.format(lengde) + " m, males med " + malingstype.finnNavn();
  }
}