/*
 * KlientImpl.java   E.L. 2004-10-11
 *
 * Implementerer interfacet Klient
 */

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class KlientImpl extends UnicastRemoteObject implements Klient {
  private String navn;
  private TelleVindu vinduet;

  public KlientImpl(String startNavn) throws RemoteException {
    navn = startNavn;
  }

  public void settVindu(TelleVindu nyttVindu) throws RemoteException {
    vinduet = nyttVindu;
  }

  public synchronized String finnNavn() throws RemoteException {
    return navn;
  }

  public synchronized void skrivStatus(String[] status) throws RemoteException {
    vinduet.settStatus(status);
  }
}

